import * as angular from 'angular';

class AddContentService {
    Authorization: string;
    /*@ngInject*/
    constructor(
        private $q,
        private $http,
        private TokenService
    ) {
        this.Authorization = this.TokenService.getAuthToken();
    }

    saveAddContent = (addContent) => {
        addContent.tags = addContent.tags
            .filter((tag) => tag.selected)
            .map((tag) => tag.id);

        return this.$http({
            method: 'POST',
            url: `${process.env.ADD_CONTENT_BFF_URL}/add-content`,
            headers: {
                'Authorization': this.Authorization,
            },
            data: addContent
        })
    };

    saveLegalAgreement = (userId, companyId) => {
        return this.$http({
            method: 'POST',
            url: `${process.env.ADD_CONTENT_API_URL}/legal-agreement`,
            headers: {
                'Authorization': this.Authorization,
            },
            data: { userId, companyId }
        });
    };

    getLegalAgreement = (companyId, userId) => {
        const deferred = this.$q.defer();

        this.$http({
            method: 'GET',
            url: `${process.env.ADD_CONTENT_API_URL}/legal-agreement/${companyId}/${userId}`,
            headers: {
                'Authorization': this.Authorization,
            }
        })
            .then(response => {
                deferred.resolve(response.data);
            })
            .catch(deferred.reject);

        return deferred.promise;
    };
}

export default AddContentService;
